<?php

namespace Modules\CADSUP\Controllers;

class Fornecedor {
    protected $connection;
    protected $Utils;
    
    public function __construct($connection, $UtilsIntegracao){
        $this->connection = $connection;
        $this->Utils = $UtilsIntegracao;
    }
    
    /**
     * www.apiteknisa.com/cadSup/fornecedor?IDSITUCADA=A&DTCADAFORN=01/01/2000
    */
    
    public function endpointGetFornecedor($request, $response){
        try{
            $conditions = '';
            $idsitucada = strtoupper($this->Utils->parametro($request, 'IDSITUCADA'));
            $dtcadaforn = $this->Utils->parametro($request, 'DTCADAFORN');
            
            if ($idsitucada === 'N' || $idsitucada === 'S' || $idsitucada === 'A') {
                if ($idsitucada === 'N') $idsitucada = 'I';
                else if ($idsitucada === 'S') $idsitucada = 'A';
                else $idsitucada = 'I_A_';
            } else $this->Utils->incluiMensagem('Tipo de situação informado não é um valor válido. Espera-se: S (Ativo), N (Inativo) ou A (Ambos)', true);
            
            if(empty($dtcadaforn)) $this->Utils->incluiMensagem('Data não informada', true);
            
            if(!$this->Utils->dataValida($dtcadaforn)) $this->Utils->incluiMensagem("Data informada não é um valor válido", true);
            
            if($this->Utils->statusAtual() == 'E'){
                $this->Utils->retornoJSONStatusMensagem($response);
                return;    
            }
            
            $query = "SELECT F.IDTPIJURFORN, F.NRINSJURFORN, F.NMRAZSOCFORN, F.NMFANTFORN, F.NRINSESTFORN, F.NRINSMUNFORN,
                    	F.IDSITUCADA, TO_CHAR(F.DTCADAFORN, 'DD/MM/YYYY') AS DTCADAFORN, EF.IDTPENDEFORN, EF.NRCEPFORN, EF.DSENDEFORNSEP, EF.NRENDEFORNSEP, 
                    	EF.DSCOMPENDFOR,  EF.NMBAIRFORN, EF.CDPAIS, P.NMPAIS, EF.SGESTADO, E.NMESTADO, 
                    	EF.CDMUNICIPIO, M.NMMUNICIPIO, EF.NMCONTFORN, EF.NRTELEFORN, EF.NRRAMALFORN,
                    	EF.NRTELEFORN1, EF.NRRAMALFORN1, EF.NRTELRESIFOR , EF.NRCELULARFOR, 
                    	EF.NRFAXFORNSEP, EF.DSEMAILFORN
                      FROM FORNECEDOR F
                       LEFT JOIN ENDEFORN EF ON EF.IDTPENDEFORN = 'P'
                       AND EF.CDFORNECED = F.CDFORNECED
                     INNER JOIN PAIS       P ON P.CDPAIS = EF.CDPAIS
                     INNER JOIN ESTADO     E ON E.CDPAIS = EF.CDPAIS
                       AND E.SGESTADO = EF.SGESTADO
                     INNER JOIN MUNICIPIO  M ON M.CDPAIS = EF.CDPAIS
                       AND M.SGESTADO = EF.SGESTADO
                       AND M.CDMUNICIPIO = EF.CDMUNICIPIO
                      LEFT JOIN BAIRRO     B ON B.NMBAIRRO = EF.NMBAIRFORN
                       AND B.CDMUNICIPIO = EF.CDMUNICIPIO
                       AND B.CDPAIS = EF.CDPAIS
                       AND B.SGESTADO = EF.SGESTADO 
                     WHERE INSTR(:IDSITUCADA, F.IDSITUCADA) > 0 
                        AND F.DTCADAFORN >= :DTCADAFORN
                     ORDER BY F.NRINSJURFORN";

            $params = [
                "DTCADAFORN" => $dtcadaforn,
                "IDSITUCADA" => $idsitucada
            ];
            
            $prepared = $this->connection->prepare($query);
            $prepared->execute($params);
            $data = $prepared->fetchAll();
            $this->Utils->retornoJSON($response, $data);
        }catch(\Exception $e){
            if($this->Utils->modoDesenvolvedor())
                throw $e;
            $this->Utils->incluiMensagem("Ocorreu um erro não esperado na execução da rotina. Verifique os parâmetros e tente novamente", true);
            $this->Utils->retornoJSONStatusMensagem($response);
        }
    }
}