/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRUPOFISCAL                                              */
/* Tabela : GRUPOFISCAL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GRUPOFISCAL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GRUPOFISCAL
GO

CREATE TRIGGER DTULTATU_GRUPOFISCAL
ON GRUPOFISCAL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GRUPOFISCAL', null, 'CDGRUPOFISC=' + CDGRUPOFISC + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GRUPOFISCAL
      SET DTULTATUGRFS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(GRUPOFISCAL.CDGRUPOFISC,0) = ISNULL(INSERTED.CDGRUPOFISC,0)) AND
            (ISNULL(GRUPOFISCAL.DSGRUPOFISC,0) = ISNULL(INSERTED.DSGRUPOFISC,0)) ;
   END;
END;
GO

